#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <curses.h>

#ifdef linux
#define	sig_t	void
#else
#  ifdef sun
#  define	sig_t	int
#  endif
#endif

#define	BUFSIZE		256
#define	COLMAX		80
#define	ROWMAX		128
#define	TERMCAPBUF	1024
#define	DELEMETER	\
"================================================================================"

static char cmd[] = "/bin/telnet korea.stanford.edu 1992";

int in_curse = 0;

sig_t die ()
{
  if (in_curse)
    {
      clear ();
      nocbreak ();
      echo ();
      endwin ();
    }
  printf ("\n\nHey! You're not supposed to do this!! Get out!\n");
  exit (0);
}

main (ac, av, ev)
     int ac;
     char *av[];
     char *ev[];
{
  FILE *in;
  register int c, count, i, j, DONE, linenum, statusline;
  char line[ROWMAX][COLMAX+1];
  char tbuf[TERMCAPBUF];
  register char *term;

  if ((term = getenv ("TERM")) == NULL)
    {
      perror ("getenv");
      exit (1);
    }
  if (tgetent (tbuf, term) != 1)
    {
      perror ("tgetent");
      exit (1);
    }

  signal (SIGHUP, (sig_t (*)()) die);
  signal (SIGINT, (sig_t (*)()) die);
  signal (SIGQUIT, (sig_t (*)()) die);
  signal (SIGILL, (sig_t (*)()) die);
  signal (SIGTERM, (sig_t (*)()) die);
  signal (SIGSTOP, SIG_IGN);
#ifdef SIGTSTP
  signal (SIGTSTP, SIG_IGN);
#endif
  signal (SIGCONT, (sig_t (*)()) die);

  /* I don't want this error messages from telnet */
  close (2);

  in_curse = 1;
  initscr ();
  noecho ();
  cbreak ();
  mvaddstr(10, 20, "Getting Info. from HanaBB.........");
  refresh();

  if ((in = popen (cmd, "r")) == NULL)
    {
      clear ();
      refresh();
      nocbreak ();
      echo ();
      endwin ();

      printf("popen() failed!\n");
      exit (1);
    }
  for (count = 0; count < ROWMAX && fgets (line[count], COLMAX, in); count++);
  pclose (in);

  linenum = tgetnum ("li");
  linenum--;
  statusline = linenum;
  linenum--;

  move (0, 0);
  clear ();
  for (i = 0, j = 0, DONE = 0; !DONE;)
    {
      if (j < linenum && i < count)
	{
	  mvaddstr (j, 0, line[i]);
	  refresh ();
	  j++;
	  i++;
	  continue;
	}
      mvaddstr(linenum, 0, DELEMETER);
      move (statusline, 0);
      standout();
      addstr("[B/P]");
      standend();
      addstr("-Prev Page / ");
      standout();
      addstr("[Q]");
      standend();
      addstr("-Quit / ");
      standout();
      addstr("[Any]");
      standend();
      addstr(" Key to Continue: ");
      refresh ();
      switch (c = getch ())
	{
	case 'B':
	case 'b':
	case 'P':
	case 'p':
	  if (i > linenum * 2)
	    i -= linenum * 2;
	  else
	    i = 0;
	  break;

	case 'Q':
	case 'q':
	  DONE = 1;
	  break;
	default:
	  if (i == count)
	    DONE = 1;
	  break;
	}
      j = 0;
      clear ();
    }
  clear ();
  refresh();
  nocbreak ();
  echo ();
  endwin ();
  return 0;
}
